/* rexx */
/*
 * Program:	Driver Linkage Generator
 *
 * Author:	Nicholas Sheppard from David Nugent
 *		Internet: nps@zeta.org.au
 *
 * Date:	22 November 2001
 * Last Edited:	1 April 2007
 *
 * The IMAP toolkit provided in this Distribution is
 * Copyright 2000 University of Washington.
 *
 * The full text of our legal notices is contained in the file called
 * CPYRIGHT, included with this Distribution.
 */

'@echo off'

/* erase old driver linkage */
'if exist linkage.h del linkage.h'
'if exist linkage.c del linkage.c'

/* now define the new list */
parse arg args
n = words(args)
do i=2 to n
  arg=word(args,i)
  call lineout 'linkage.h', 'extern DRIVER '||arg||'driver;'
  call lineout 'linkage.c', '  mail_link  (&'arg'driver);	/* link in the' arg 'driver */'
  call lineout 'c-client.def', '  '||arg||'driver'
end

/* define default driver */
arg=word(args,1)
call lineout 'linkage.h', '#define DEFAULTPROTO '||arg||'proto'


/* add in mm_* callbacks */
call lineout 'linkage.c', '  {'
call lineout 'linkage.c', '    static struct mm_callbacks os2callbacks = {'
call lineout 'linkage.c', '      mm_searched,'
call lineout 'linkage.c', '      mm_exists,'
call lineout 'linkage.c', '      mm_expunged,'
call lineout 'linkage.c', '      mm_flags,'
call lineout 'linkage.c', '      mm_list,'
call lineout 'linkage.c', '      mm_lsub,'
call lineout 'linkage.c', '      mm_log,'
call lineout 'linkage.c', '      mm_dlog,'
call lineout 'linkage.c', '      mm_login,'
call lineout 'linkage.c', '      mm_notify,'
call lineout 'linkage.c', '      mm_status,'
call lineout 'linkage.c', '      mm_critical,'
call lineout 'linkage.c', '      mm_nocritical,'
call lineout 'linkage.c', '      mm_diskerror,'
call lineout 'linkage.c', '      mm_fatal'
call lineout 'linkage.c', '    };'
call lineout 'linkage.c', '    os2_cclient_link(&os2callbacks);'
call lineout 'linkage.c', '  }'

exit 0
