/*
 * Program:	OS/2 environment routines
 *
 * Author:	Mark Crispin
 *		Networks and Distributed Computing
 *		Computing & Communications
 *		University of Washington
 *		Administration Building, AG-44
 *		Seattle, WA  98195
 *		Internet: MRC@CAC.Washington.EDU
 *
 * Date:	1 August 1988
 * Last Edited:	15 December 2001
 *
 * The IMAP toolkit provided in this Distribution is
 * Copyright 2000 University of Washington.
 * The full text of our legal notices is contained in the file called
 * CPYRIGHT, included with this Distribution.
 */

#include "env.h"

#define SUBSCRIPTIONFILE(t) sprintf (t,"%s\\mailbox.lst",myhomedir ())
#define SUBSCRIPTIONTEMP(t) sprintf (t,"%s\\mailbox.tmp",myhomedir ())

#define MD5ENABLE		os2_md5_enable()
#define SSL_CERT_DIRECTORY	os2_ssl_certs()

#define L_SET	SEEK_SET


/* Special users */

#define ANONYMOUSUSER "nobody"	/* anonymous user */
#define UNLOGGEDUSER "os2user"	/* unlogged-in user */


#define myusername()	myusername_full(NIL)

void rfc822_fixed_date (char *date);
long env_init (char *user,char *home);
char *os2_homedir (char *user);
static char defaultDrive (void);
char *myusername_full (unsigned long *flags);
#define MU_LOGGEDIN 0
#define MU_NOTLOGGEDIN 1
#define MU_ANONYMOUS 2

char *sysinbox ();
char *mailboxdir (char *dst,char *dir,char *name);
struct passwd *checkpw (struct passwd *pw,char *pass,int argc,char *argv[]);
long loginpw (struct passwd *pw,int argc,char *argv[]);
long pw_login (struct passwd *pw,char *auser,char *user,char *home,int argc,
	       char *argv[]);
char *os2_md5_enable ();
char *os2_ssl_certs ();
long path_create (MAILSTREAM *stream,char *mailbox);
void grim_pid_reap_status (int pid,int killreq,void *status);
#define grim_pid_reap(pid,killreq) \
  grim_pid_reap_status (pid,killreq,NIL)
void *mm_blocknotify (int reason,void *data);
