/*
 * Program:	DLL callbacks for OS/2
 *
 * Author:	Nicholas Sheppard from David Nugent
 *		Internet: nps@zeta.org.au
 *
 * Date:	22 November 2001
 * Last Edited:	22 November 2001
 * 
 * The IMAP toolkit provided in this Distribution is
 * Copyright 2001 University of Washington.
 * The full text of our legal notices is contained in the file called
 * CPYRIGHT, included with this Distribution.
 */

#include "mail.h"
#include "osdep.h"

static struct mm_callbacks MM;

void mm_searched(MAILSTREAM *s,unsigned long n)
{
  if (MM.searched) MM.searched(s,n);
}

void mm_exists(MAILSTREAM *s,unsigned long n)
{
  if (MM.exists) MM.exists(s,n);
}

void mm_expunged(MAILSTREAM *s,unsigned long n)
{
  if (MM.expunged) MM.expunged(s,n);
}

void mm_flags(MAILSTREAM *s,unsigned long n)
{
  if (MM.flags) MM.flags(s,n);
}

void mm_list(MAILSTREAM *s,int delimiter,char *name,long attributes)
{
  if (MM.list) MM.list(s,delimiter,name,attributes);
}

void mm_log(char *s,long e)
{
  if (MM.log) MM.log(s, e);
}

void mm_dlog(char *s)
{
  if (MM.dlog) MM.dlog(s);
}

void mm_login(NETMBX *mb,char *user,char *pwd,long trial)
{
  if (MM.login) MM.login(mb,user,pwd,trial);
}

void mm_lsub(MAILSTREAM *s,int delimiter,char *name,long attributes)
{
  if (MM.lsub) MM.list(s,delimiter,name,attributes);
}

void mm_notify(MAILSTREAM *s,char *m,long e)
{
  if (MM.notify) MM.notify(s, m, e);
}

void mm_status (MAILSTREAM *s,char *mailbox,MAILSTATUS *status)
{
  if (MM.status) MM.status(s,mailbox,status);
}

void mm_critical(MAILSTREAM *s)
{
  if (MM.critical) MM.critical(s);
}

void mm_nocritical(MAILSTREAM *s)
{
  if (MM.nocritical) MM.nocritical(s);
}

long mm_diskerror(MAILSTREAM *s,long err,long serious)
{
  return (MM.diskerror) ? MM.diskerror(s,err,serious) : 0;
}

void mm_fatal(char *s)
{
  if (MM.fatal) MM.fatal(s);
}

void os2_cclient_link(struct mm_callbacks *cb)
{
  /* init callbacks */
  MM = *cb;
}
