/* rexx */
/*
 * Program:	Authenticator Linkage Generator
 *
 * Author:	Nicholas Sheppard from Mark Crispin
 *		Internet: nps$zeta.org.au
 *
 * Date:	22 November 2001
 * Last Edited:	1 April 2007
 *
 * The IMAP toolkit provided in this Distribution is
 * Copyright 2000 University of Washington.
 *
 * The full text of our legal notices is contained in the file called
 * CPYRIGHT, included with this Distribution.
 */

'@echo off'

/* Erase old authenticators list */
'if exist auths.c del auths.c'

/* now define the new list */
parse arg args
n = words(args)
do i=1 to n
  arg=word(args,i)
  call lineout 'linkage.h', 'extern AUTHENTICATOR auth_'||arg||';'
  call lineout 'linkage.c', '  auth_link  (&auth_'||arg||');		/* link in the' arg 'authenticator */'
  call lineout 'auths.c', '#include "auth_'||arg||'.c"'
  call lineout 'c-client.def', '  auth_'||arg
end

exit 0
