/*
 * Program:	Operating-system dependent routines -- OS/2 version
 *
 * Author:	Mark Crispin
 *		Networks and Distributed Computing
 *		Computing & Communications
 *		University of Washington
 *		Administration Building, AG-44
 *		Seattle, WA  98195
 *		Internet: MRC@CAC.Washington.EDU
 *
 * Date:	11 May 1989
 * Last Edited:	10 June 2007
 * 
 * The IMAP toolkit provided in this Distribution is
 * Copyright 2001 University of Washington.
 * The full text of our legal notices is contained in the file called
 * CPYRIGHT, included with this Distribution.
 */

/* re-defines errno as _errno() for the multi-threaded libraries */
#ifndef __ST_MT_ERRNO__
#define __ST_MT_ERRNO__
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <syslog.h>

#include "env_os2.h"
#include "fs.h"
#include "ftl.h"
#include "nl.h"
#include "tcp.h"
#include "yunchan.h"

/* EMX wants to have const in these prototypes */
char *strtok(char *s,const char *ct);
char *strtok_r (char *s,const char *ct,char **r);

/* define some things missing from EMX <sys/stat.h> */
#define lstat stat
#ifndef S_IFBLK
#define	S_IFBLK	 0060000		/* block special */
#endif
#ifndef S_IFLNK
#define	S_IFLNK	 0120000		/* symbolic link */
#endif

#ifndef _OS_OS2_H
#define _OS_OS2_H

struct mm_callbacks {
  void (*searched)(MAILSTREAM*s,unsigned long n);
  void (*exists)(MAILSTREAM*s,unsigned long n);
  void (*expunged)(MAILSTREAM*s,unsigned long n);
  void (*flags)(MAILSTREAM*s,unsigned long n);
  void (*list)(MAILSTREAM*ss,int delimiter,char *name,long attributes);
  void (*lsub)(MAILSTREAM*ss,int delimiter,char *name,long attributes);
  void (*log)(char *s, long errflg);
  void (*dlog)(char *s);
  void (*login)(NETMBX *mb,char *user,char *pwd,long trial);
  void (*notify)(MAILSTREAM *s,char *m,long e);
  void (*status)(MAILSTREAM *s,char *mailbox,MAILSTATUS *status);
  void (*critical)(MAILSTREAM *s);
  void (*nocritical)(MAILSTREAM *s);
  long (*diskerror)(MAILSTREAM *s,long err,long serious);
  void (*fatal)(char *s);
};

extern void os2_cclient_link(struct mm_callbacks *mmcb);

#endif
