/*
 * These values are supposed to be set by the make file but this is not
 * easy to do in an OS/2 shell, so I'm just going to make them up for now.
 * NPS 20/04/2008
 */
char datestamp[]="Sun 20 April 2008";
char hoststamp[]="os2box";
char compstamp[]="156";


/******************************************************************************
 *
 * Local implementations of Unix functions.
 */

#define INCL_DOSERRORS
#include <os2.h>

#include <errno.h>
#include <sys/types.h>

#define MAXPATHLEN 256

/*
 * os2_getcwd - get the current working directory
 */
char *
os2_getcwd(char *buf, size_t len)
{
    ULONG drive;
    ULONG ul;
    CHAR  dir[MAXPATHLEN];

    /* sanity check */
    if (len <= 0) {
        errno = EINVAL;
        return NULL;
    }

    /* get the current drive */
    DosQueryCurrentDisk(&drive, &ul);

    /* get the directory on this drive */
    ul = MAXPATHLEN;
    DosQueryCurrentDir(drive, dir, &ul);

    /* copy it into the buffer */
    ul = strlen(dir) + 4;
    if (buf == NULL) {
        if ((buf = (char *)malloc((len > ul)? len : ul)) == NULL) {
            errno = ENOMEM;
            return NULL;
        }
    } else {
        if (ul > len) {
            errno = ERANGE;
            return NULL;
        }
    }
    sprintf(buf, "%c:\\%s", 'A' + drive - 1, dir);

    return (buf);
}


/*
 * os2_getdcwd - get the current working directory of a drive
 */
char *
os2_getdcwd(int drive, char *buf, size_t len)
{
    ULONG ul;
    CHAR  dir[MAXPATHLEN];

    ul = MAXPATHLEN;
    DosQueryCurrentDir(drive, dir, &ul);
    ul = strlen(dir) + 1;
    if (buf == NULL) {
        if ((buf = (char *)malloc((len > ul)? len : ul)) == NULL) {
            errno = ENOMEM;
            return NULL;
        }
    } else {
        if (ul > len) {
            errno = ERANGE;
            return NULL;
        }
    }
    strcpy(buf, dir);

    return (buf);
}


/*
 * setpgrp() - (pretend to) set process group id
 */
int
setpgrp(pid_t pid, pid_t pgid)
{
    return (0);
}


/******************************************************************************
 *
 * Local implementations of Pico functions.
 */


/*
 * fixpath - make the given pathname into an absolute path, incoming
 *           name is UTF-8.
 */
void
fixpath(char *name, size_t namelen)
{
    char file[MAXPATHLEN];
    int  dr;

    if(!namelen)
      return;
    
    /* return the full path of given file, so drive spec? */
    if(name[1] == ':' && isalpha((unsigned char) name[0])){
	if(name[2] != '\\'){				  /* including path? */
	    dr = toupper((unsigned char)name[0]) - 'A' + 1;
	    if((void *)os2_getdcwd(dr, file, MAXPATHLEN) != NULL){
		if(file[strlen(file)-1] != '\\')
		  strncat(file, "\\", sizeof(file)-1-strlen(file));

		/* add file name */
		strncat(file, &name[2], sizeof(file)-1-strlen(file));
	    }
	    else
	      return;
	}
	else
	  return;		/* fully qualified with drive and path! */
    }
    else if(name[0] == '\\' && name[1] != '\\') {     /* no drive spec! */
	sprintf(file, "%c:%.*s", _getdrive(), namelen-3, name);
    }
    else if(name[0] == '\\' && name[1] == '\\'){  /* Windows network drive */
      return;
    }
    else{
	if(!os2_getcwd(file, sizeof(file)))	/* no qualification */
	  return;

	if(*name){				/* if name, append it */
	    if(*file && file[strlen(file)-1] != '\\')
	      strncat(file, "\\", sizeof(file)-1-strlen(file));

	    strncat(file, name, sizeof(file)-1-strlen(file));
	}
    }

    strncpy(name, file, namelen-1);    		/* copy back to real buffer */
    name[namelen-1] = '\0';			/* tie off just in case */
}
